require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(defined(&__NetBSD__)) {
    require 'sys/device.ph';
}
 elsif(defined(&__FreeBSD__)) {
    require 'sys/module.ph';
    require 'sys/bus.ph';
}
if(defined(&__NetBSD__)) {
    eval 'sub DEVPORT_DEVICE () {\'struct device\';}' unless defined(&DEVPORT_DEVICE);
    eval 'sub DEVPORT_DEVNAME {
        my($dev) = @_;
	    eval q(($dev). &dv_xname);
    }' unless defined(&DEVPORT_DEVNAME);
    eval 'sub DEVPORT_DEVUNIT {
        my($dev) = @_;
	    eval q(($dev). &dv_unit);
    }' unless defined(&DEVPORT_DEVUNIT);
}
 elsif(defined(&__FreeBSD__)) {
    eval 'sub DEVPORT_DEVICE () { &device_t;}' unless defined(&DEVPORT_DEVICE);
    eval 'sub DEVPORT_DEVNAME {
        my($dev) = @_;
	    eval q( &device_get_name($dev));
    }' unless defined(&DEVPORT_DEVNAME);
    eval 'sub DEVPORT_DEVUNIT {
        my($dev) = @_;
	    eval q( &device_get_unit($dev));
    }' unless defined(&DEVPORT_DEVUNIT);
    eval 'sub DEVPORT_ALLOC_SOFTC {
        my($dev) = @_;
	    eval q( &device_get_softc($dev));
    }' unless defined(&DEVPORT_ALLOC_SOFTC);
    eval 'sub DEVPORT_GET_SOFTC {
        my($dev) = @_;
	    eval q( &device_get_softc($dev));
    }' unless defined(&DEVPORT_GET_SOFTC);
    eval 'sub UNCONF () {1;}' unless defined(&UNCONF);
    eval 'sub DEVPORT_PDEVICE () { &device_t;}' unless defined(&DEVPORT_PDEVICE);
    eval 'sub DEVPORT_PDEVUNIT {
        my($pdev) = @_;
	    eval q( &device_get_unit($pdev));
    }' unless defined(&DEVPORT_PDEVUNIT);
    eval 'sub DEVPORT_PDEVFLAGS {
        my($pdev) = @_;
	    eval q( &device_get_flags($pdev));
    }' unless defined(&DEVPORT_PDEVFLAGS);
    eval 'sub DEVPORT_PDEVIOBASE {
        my($pdev) = @_;
	    eval q( &bus_get_resource_start($pdev,  &SYS_RES_IOPORT, 0));
    }' unless defined(&DEVPORT_PDEVIOBASE);
    eval 'sub DEVPORT_PDEVIRQ {
        my($pdev) = @_;
	    eval q( &bus_get_resource_start($pdev,  &SYS_RES_IRQ, 0));
    }' unless defined(&DEVPORT_PDEVIRQ);
    eval 'sub DEVPORT_PDEVMADDR {
        my($pdev) = @_;
	    eval q( &bus_get_resource_start($pdev,  &SYS_RES_MEMORY, 0));
    }' unless defined(&DEVPORT_PDEVMADDR);
    eval 'sub DEVPORT_PDEVALLOC_SOFTC {
        my($pdev) = @_;
	    eval q( &device_get_softc($pdev));
    }' unless defined(&DEVPORT_PDEVALLOC_SOFTC);
    eval 'sub DEVPORT_PDEVGET_SOFTC {
        my($pdev) = @_;
	    eval q( &device_get_softc($pdev));
    }' unless defined(&DEVPORT_PDEVGET_SOFTC);
}
1;
